DECLARE FUNCTION Such$ (File AS INTEGER, Gesucht AS STRING)

FUNCTION Such$ (File AS INTEGER, Gesucht AS STRING) STATIC

   CONST MaxZeilenLaenge = 80
   CONST BufferGroesse = MaxZeilenLaenge * 2 + 2

   DIM Buffer AS STRING * BufferGroesse
   DIM Zeile AS STRING, Pruefen AS STRING
   DIM Mitte AS LONG, Links AS LONG, Rechts AS LONG
   DIM Anfang AS INTEGER, Ende AS INTEGER

   Rechts = LOF(File): Links = 1
   Such$ = ""

   DO
      Mitte = (Links + Rechts) \ 2
      GET #File, Mitte, Buffer
      IF Mitte = 1 THEN
         Anfang = 1
      ELSE
         ' Vor dem Anfang einer neuen Zeile steht immer
         ' die Kombination CHR$(13) + CHR$(10), also
         ' fngt die nchste Zeile hinter dem nchsten
         ' CHR$(10) an:
         Anfang = INSTR(Buffer, CHR$(10)) + 1
      END IF
      Pruefen = MID$(Buffer, Anfang, LEN(Gesucht))

      IF Pruefen > Gesucht THEN
         Rechts = Mitte - 1
      ELSEIF Pruefen < Gesucht THEN
         Links = Mitte + 1
      ELSE
         Ende = INSTR(Anfang, Buffer, CHR$(13))
         IF Ende = 0 THEN Ende = LEN(Buffer) + 1
         Such$ = MID$(Buffer, Anfang, Ende - Anfang)
         EXIT DO
      END IF
   LOOP UNTIL Links = Rechts

END FUNCTION

