DECLARE FUNCTION LongTEXTCOMP% (string1 AS STRING, string2 AS STRING)
DECLARE FUNCTION LongTEXTCOMPx% (string1 AS STRING, offset1 AS INTEGER, string2 AS STRING, offset2 AS INTEGER)

FUNCTION LongTEXTCOMP% (string1 AS STRING, string2 AS STRING)

   LongTEXTCOMP% = LongTEXTCOMPx(string1, 1, string2, 1)

END FUNCTION

FUNCTION LongTEXTCOMPx% (string1 AS STRING, offset1 AS INTEGER, string2 AS STRING, offset2 AS INTEGER)

   ltc% = TEXTCOMP(MID$(string1, offset1, 255), MID$(string2, offset2, 255))
   IF ltc% = 0 THEN
      IF LEN(string1) > 254 + offset1 OR LEN(string2) > 254 + offset2 THEN
         ltc% = LongTEXTCOMPx(string1, offset1 + 255, string2, offset2 + 255)
      END IF
   END IF
   LongTEXTCOMPx = ltc%

END FUNCTION

